

import static util.SingleManager.em;
import static util.SingleManager.trans;

import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.EOFException;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;

import org.yanglai.io.RandomAccessFile;

import util.SingleManager.eClass;

import com.objectdb.Enhancer;

public class URIReader2 {
	
	@SuppressWarnings("deprecation")
	public static int read(String src, eClass eName){
		int iCnt = 0;
		long lLenAvg = 0;
		URI uri = null;
		RandomAccessFile din = null;
		int iSpan = 0xFF;
		try {
			din = new RandomAccessFile(src, "r");
			long Len = din.length();
			trans.begin();
			while (lLenAvg/5 + din.getPos()<Len){
				switch (eName){
				case Page:
//					uri = new Page();
					break;
				case Image:
					uri = new ImageSogou();
					break;
				case Thumb:
					uri = new Thumb();
					break;
				}
				String sLine;
				sLine = din.readLine().trim();
				while (null==sLine || sLine.length()==0){
					sLine = din.readLine();
				}
				uri.setsUrl(sLine);
				char cMark = ' ';
				sLine = din.readLine().trim();
				try {
					cMark = sLine.toLowerCase().charAt(0);
				} catch (Exception e1) {
					e1.printStackTrace();
					throw new IllegalAccessError("Error for mark");
				}
				uri.setcMark(cMark);
				switch (cMark){
				case 'p':
					String sSize = din.readLine();
					int iSize;
					try {
						iSize = Integer.parseInt(sSize);
					} catch (NumberFormatException e) {
						e.printStackTrace();
						System.out.println(String.format("Url: %s%nSize:%d%n%n", uri.getsUrl(), uri.getiSize()));
						iSize = 0xFFFFF;
					}
					byte[] baB = new byte[iSize];
					iSize = din.read(baB, 0, iSize);
					uri.setiSize(iSize);
					uri.setBaURI(baB);
//					System.out.println(new String(baB));
					din.readLine();
					break;
				case '=':
					break;
				case 'd':
					break;
				}
				em.persist(uri);
				if ((++iCnt & iSpan)==0){
					trans.commit();
					System.out.printf("NO = %d @ %d%n",iCnt, Len);
					System.out.printf("id = %d @ %d%n",uri.getId(), din.getPos());
					System.out.printf("Url = %s%n%n", uri.getsUrl());
					em.clear();
					trans.begin();
				}
				lLenAvg = din.getPos() / iCnt;
			}
			trans.commit();
			din.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (EOFException e){
			e.printStackTrace();
			System.out.printf("_____________File reach End! Close it Now!_________%n");
		} catch (IOException e) {
			e.printStackTrace();
		}finally{
			/*
			trans.commit();
			try {
				din.close();
			} catch (IOException e) {
				e.printStackTrace();
			}//*/
		}
		
		return iCnt;
	}
	public static void main(String[] args) {
		int i2 = URIReader2.read("images", eClass.Image);
//		int i2 = URIReader.read("r:/SogouPIC/original_pic", eClass.Image);
//		int i3 = URIReader.read("r:/SogouPIC/zoomed_pic", eClass.Thumb);
//		int i1 = URIReader.read("r:/SogouPIC/pages", eClass.Page);
//		System.out.printf("pages = %d%n",i1);
//		System.out.printf("Images = %d%n",i2);
//		System.out.printf("Thumbs = %d%n",i3);
	}
}
@Entity
@Inheritance(strategy=InheritanceType.JOINED)
@DiscriminatorColumn(discriminatorType=DiscriminatorType.INTEGER,name="type")
@DiscriminatorValue(value="71")
class URI {
	public URI() {
	}
	byte[] baURI;
	char cMark;
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof URI){
			URI u = (URI)obj;
			if (sUrl.equals(u.getsUrl()) && iSize==u.getiSize())
				return true;
			else
				return false;
		}
		return false;
	}
	@Override
	public int hashCode() {
		return sUrl.hashCode();
	}
	@Id
    @GeneratedValue(strategy=GenerationType.IDENTITY)
	int id;
	int iSize;
	String sUrl;
	public byte[] getBaURI() {
		return baURI;
	}
	public char getcMark() {
		return cMark;
	}
	public int getId() {
		return id;
	}
	public int getiSize() {
		return iSize;
	}
	public String getsUrl() {
		return sUrl;
	}
	public void setBaURI(byte[] baURI) {
		this.baURI = baURI;
	}
	public void setcMark(char cMark) {
		this.cMark = cMark;
	}
	public void setiSize(int iSize) {
		this.iSize = iSize;
	}
	public void setsUrl(String sUrl) {
		this.sUrl = sUrl;
	}

}
@Entity
@Inheritance(strategy=InheritanceType.JOINED)
@DiscriminatorColumn(discriminatorType=DiscriminatorType.INTEGER,name="type")
@DiscriminatorValue(value="74")
class Thumb extends URI {
	public Thumb(){}
	@Override
	public byte[] getBaURI() {
		return baURI;
	}
	@Override
	public void setBaURI(byte[] baURI) {
		this.baURI = baURI;
	}
	public BufferedImage getBaImage() {
		ByteArrayInputStream bin = new ByteArrayInputStream(getBaURI());
		try {
			return javax.imageio.ImageIO.read(bin);
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

}
@Entity
@DiscriminatorColumn(discriminatorType=DiscriminatorType.INTEGER,name="type")
@DiscriminatorValue(value="75")
class ImageSogou extends Thumb{
	public ImageSogou(){}
}
